Index: /branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Annex_ISO.tex
===================================================================
--- /branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Annex_ISO.tex	(revision 9363)
+++ /branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Annex_ISO.tex	(revision 9364)
@@ -9,5 +9,5 @@
 \minitoc
 \pagebreak
-\section{Choice of \ngn{namtra\_ldf} namelist parameters}
+\section{Choice of \protect\ngn{namtra\_ldf} namelist parameters}
 %-----------------------------------------nam_traldf------------------------------------------------------
 \namdisplay{namtra_ldf}
@@ -112,5 +112,5 @@
 \end{equation}
 Additionally, we will sometimes write the contributions towards the
-fluxes $\vect{f}$ and $\vect{F}_\mathrm{iso}$ from the component
+fluxes $\vect{f}$ and $\vect{F}_{\mathrm{iso}}$ from the component
 $R_{ij}$ of $\Re$ as $f_{ij}$, $F_{\mathrm{iso}\: ij}$, with
 $f_{ij}=R_{ij}e_i^{-1}\partial T/\partial x_i$ (no summation) etc.
@@ -193,5 +193,5 @@
 \begin{figure}[tb] \begin{center}
     \includegraphics[width=1.05\textwidth]{Fig_GRIFF_triad_fluxes}
-    \caption{ \label{fig:triad:ISO_triad}
+    \caption{ \protect\label{fig:triad:ISO_triad}
       (a) Arrangement of triads $S_i$ and tracer gradients to
            give lateral tracer flux from box $i,k$ to $i+1,k$
@@ -257,5 +257,5 @@
 \begin{figure}[tb] \begin{center}
     \includegraphics[width=0.80\textwidth]{Fig_GRIFF_qcells}
-    \caption{   \label{fig:triad:qcells}
+    \caption{   \protect\label{fig:triad:qcells}
     Triad notation for quarter cells. $T$-cells are inside
       boxes, while the  $i+\half,k$ $u$-cell is shaded in green and the
@@ -360,5 +360,5 @@
 $w$-points as sums of the triad fluxes that cross the $u$- and $w$-faces:
 %(Fig.~\ref{Fig_ISO_triad}):
-\begin{flalign} \label{Eq_iso_flux} \vect{F}_\mathrm{iso}(T) &\equiv
+\begin{flalign} \label{Eq_iso_flux} \vect{F}_{\mathrm{iso}}(T) &\equiv
   \sum_{\substack{i_p,\,k_p}}
   \begin{pmatrix}
@@ -506,5 +506,5 @@
 \begin{subequations}\label{eq:triad:alltriadflux}
   \begin{flalign}\label{eq:triad:vect_isoflux}
-    \vect{F}_\mathrm{iso}(T) &\equiv
+    \vect{F}_{\mathrm{iso}}(T) &\equiv
     \sum_{\substack{i_p,\,k_p}}
     \begin{pmatrix}
@@ -661,5 +661,5 @@
 \begin{figure}[h] \begin{center}
     \includegraphics[width=0.60\textwidth]{Fig_GRIFF_bdry_triads}
-    \caption{  \label{fig:triad:bdry_triads}
+    \caption{  \protect\label{fig:triad:bdry_triads}
       (a) Uppermost model layer $k=1$ with $i,1$ and $i+1,1$ tracer
       points (black dots), and $i+1/2,1$ $u$-point (blue square). Triad
@@ -669,11 +669,11 @@
       $\triad[u]{i}{1}{F}{1/2}{-1/2}$ and $\triad[u]{i+1}{1}{F}{-1/2}{-1/2}$
       (yellow line) are still applied, giving diapycnal diffusive
-      fluxes.\\
+      fluxes.\newline
       (b) Both near bottom triad slopes $\triad{i}{k}{R}{1/2}{1/2}$ and
       $\triad{i+1}{k}{R}{-1/2}{1/2}$ are masked when either of the $i,k+1$
       or $i+1,k+1$ tracer points is masked, i.e.\ the $i,k+1$ $u$-point
       is masked. The associated lateral fluxes (grey-black dashed
-      line) are masked if \np{botmix\_triad}=.false., but left
-      unmasked, giving bottom mixing, if \np{botmix\_triad}=.true.}
+      line) are masked if \protect\np{botmix\_triad}=.false., but left
+      unmasked, giving bottom mixing, if \protect\np{botmix\_triad}=.true.}
  \end{center} \end{figure}
 % >>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -758,5 +758,5 @@
 Fig.~\ref{fig:triad:MLB_triad}), we define the mixed-layer by setting
 the vertical index of the tracer point immediately below the mixed
-layer, $k_\mathrm{ML}$, as the maximum $k$ (shallowest tracer point)
+layer, $k_{\mathrm{ML}}$, as the maximum $k$ (shallowest tracer point)
 such that the potential density
 ${\rho_0}_{i,k}>{\rho_0}_{i,k_{10}}+\Delta\rho_c$, where $i,k_{10}$ is
@@ -767,26 +767,26 @@
 $\Delta\rho_c=0.01\;\mathrm{kg\:m^{-3}}$ for ML triad tapering as is
 used to output the diagnosed mixed-layer depth
-$h_\mathrm{ML}=|z_{W}|_{k_\mathrm{ML}+1/2}$, the depth of the $w$-point
-above the $i,k_\mathrm{ML}$ tracer point.
+$h_{\mathrm{ML}}=|z_{W}|_{k_{\mathrm{ML}}+1/2}$, the depth of the $w$-point
+above the $i,k_{\mathrm{ML}}$ tracer point.
 
 \item We define `basal' triad slopes
-${\:}_i{\mathbb{R}_\mathrm{base}}_{\,i_p}^{k_p}$ as the slopes
+${\:}_i{\mathbb{R}_{\mathrm{base}}}_{\,i_p}^{k_p}$ as the slopes
 of those triads whose vertical `arms' go down from the
-$i,k_\mathrm{ML}$ tracer point to the $i,k_\mathrm{ML}-1$ tracer point
+$i,k_{\mathrm{ML}}$ tracer point to the $i,k_{\mathrm{ML}}-1$ tracer point
 below. This is to ensure that the vertical density gradients
 associated with these basal triad slopes
-${\:}_i{\mathbb{R}_\mathrm{base}}_{\,i_p}^{k_p}$ are
+${\:}_i{\mathbb{R}_{\mathrm{base}}}_{\,i_p}^{k_p}$ are
 representative of the thermocline. The four basal triads defined in the bottom part
 of Fig.~\ref{fig:triad:MLB_triad} are then
 \begin{align}
-  {\:}_i{\mathbb{R}_\mathrm{base}}_{\,i_p}^{k_p} &=
- {\:}^{k_\mathrm{ML}-k_p-1/2}_i{\mathbb{R}_\mathrm{base}}_{\,i_p}^{k_p}, \label{eq:triad:Rbase}
+  {\:}_i{\mathbb{R}_{\mathrm{base}}}_{\,i_p}^{k_p} &=
+ {\:}^{k_{\mathrm{ML}}-k_p-1/2}_i{\mathbb{R}_{\mathrm{base}}}_{\,i_p}^{k_p}, \label{eq:triad:Rbase}
 \\
 \intertext{with e.g.\ the green triad}
-{\:}_i{\mathbb{R}_\mathrm{base}}_{1/2}^{-1/2}&=
-{\:}^{k_\mathrm{ML}}_i{\mathbb{R}_\mathrm{base}}_{\,1/2}^{-1/2}. \notag
+{\:}_i{\mathbb{R}_{\mathrm{base}}}_{1/2}^{-1/2}&=
+{\:}^{k_{\mathrm{ML}}}_i{\mathbb{R}_{\mathrm{base}}}_{\,1/2}^{-1/2}. \notag
 \end{align}
 The vertical flux associated with each of these triads passes through the $w$-point
-$i,k_\mathrm{ML}-1/2$ lying \emph{below} the $i,k_\mathrm{ML}$ tracer point,
+$i,k_{\mathrm{ML}}-1/2$ lying \emph{below} the $i,k_{\mathrm{ML}}$ tracer point,
 so it is this depth
 \begin{equation}
@@ -795,19 +795,19 @@
 \end{equation}
 (one gridbox deeper than the
-diagnosed ML depth $z_\mathrm{ML})$ that sets the $h$ used to taper
+diagnosed ML depth $z_{\mathrm{ML}})$ that sets the $h$ used to taper
 the slopes in \eqref{eq:triad:rmtilde}.
 \item Finally, we calculate the adjusted triads
-${\:}_i^k{\mathbb{R}_\mathrm{ML}}_{\,i_p}^{k_p}$ within the mixed
+${\:}_i^k{\mathbb{R}_{\mathrm{ML}}}_{\,i_p}^{k_p}$ within the mixed
 layer, by multiplying the appropriate
-${\:}_i{\mathbb{R}_\mathrm{base}}_{\,i_p}^{k_p}$ by the ratio of
-the depth of the $w$-point ${z_w}_{k+k_p}$ to ${z_\mathrm{base}}_{\,i}$. For
+${\:}_i{\mathbb{R}_{\mathrm{base}}}_{\,i_p}^{k_p}$ by the ratio of
+the depth of the $w$-point ${z_w}_{k+k_p}$ to ${z_{\mathrm{base}}}_{\,i}$. For
 instance the green triad centred on $i,k$
 \begin{align}
-  {\:}_i^k{\mathbb{R}_\mathrm{ML}}_{\,1/2}^{-1/2} &=
-\frac{{z_w}_{k-1/2}}{{z_\mathrm{base}}_{\,i}}{\:}_i{\mathbb{R}_\mathrm{base}}_{\,1/2}^{-1/2}
+  {\:}_i^k{\mathbb{R}_{\mathrm{ML}}}_{\,1/2}^{-1/2} &=
+\frac{{z_w}_{k-1/2}}{{z_{\mathrm{base}}}_{\,i}}{\:}_i{\mathbb{R}_{\mathrm{base}}}_{\,1/2}^{-1/2}
 \notag \\
 \intertext{and more generally}
- {\:}_i^k{\mathbb{R}_\mathrm{ML}}_{\,i_p}^{k_p} &=
-\frac{{z_w}_{k+k_p}}{{z_\mathrm{base}}_{\,i}}{\:}_i{\mathbb{R}_\mathrm{base}}_{\,i_p}^{k_p}.\label{eq:triad:RML}
+ {\:}_i^k{\mathbb{R}_{\mathrm{ML}}}_{\,i_p}^{k_p} &=
+\frac{{z_w}_{k+k_p}}{{z_{\mathrm{base}}}_{\,i}}{\:}_i{\mathbb{R}_{\mathrm{base}}}_{\,i_p}^{k_p}.\label{eq:triad:RML}
 \end{align}
 \end{enumerate}
@@ -815,13 +815,14 @@
 % >>>>>>>>>>>>>>>>>>>>>>>>>>>>
 \begin{figure}[h]
-  \fcapside {\caption{\label{fig:triad:MLB_triad} Definition of
+%  \fcapside {
+    \caption{\protect\label{fig:triad:MLB_triad} Definition of
       mixed-layer depth and calculation of linearly tapered
       triads. The figure shows a water column at a given $i,j$
       (simplified to $i$), with the ocean surface at the top. Tracer points are denoted by
       bullets, and black lines the edges of the tracer cells; $k$
-      increases upwards. \\
+      increases upwards. \newline
       \hspace{5 em}We define the mixed-layer by setting the vertical index
       of the tracer point immediately below the mixed layer,
-      $k_\mathrm{ML}$, as the maximum $k$ (shallowest tracer point)
+      $k_{\mathrm{ML}}$, as the maximum $k$ (shallowest tracer point)
       such that ${\rho_0}_{i,k}>{\rho_0}_{i,k_{10}}+\Delta\rho_c$,
       where $i,k_{10}$ is the tracer gridbox within which the depth
@@ -829,8 +830,9 @@
       layer by linearly tapering them from zero (at the surface) to
       the `basal' slopes, the slopes of the four triads passing through the
-      $w$-point $i,k_\mathrm{ML}-1/2$ (blue square),
-      ${\:}_i{\mathbb{R}_\mathrm{base}}_{\,i_p}^{k_p}$. Triads with
+      $w$-point $i,k_{\mathrm{ML}}-1/2$ (blue square),
+      ${\:}_i{\mathbb{R}_{\mathrm{base}}}_{\,i_p}^{k_p}$. Triads with
     different $i_p,k_p$, denoted by different colours, (e.g. the green
-    triad $i_p=1/2,k_p=-1/2$) are tapered to the appropriate basal triad.}}
+    triad $i_p=1/2,k_p=-1/2$) are tapered to the appropriate basal triad.}
+%}
   {\includegraphics[width=0.60\textwidth]{Fig_GRIFF_MLB_triads}}
 \end{figure}
@@ -865,5 +867,5 @@
 not change the potential energy.
 This approach is similar to multiplying the iso-neutral  diffusion
-coefficient by $\tilde{r}_\mathrm{max}^{-2}\tilde{r}_i^{-2}$ for steep
+coefficient by $\tilde{r}_{\mathrm{max}}^{-2}\tilde{r}_i^{-2}$ for steep
 slopes, as suggested by \citet{Gerdes1991} (see also \citet{Griffies_Bk04}).
 Again it is applied separately to each triad $_i^k\mathbb{R}_{i_p}^{k_p}$
@@ -931,5 +933,5 @@
 \begin{flalign*}
 \begin{split}
-\textbf{F}_\mathrm{eiv}^T =
+\textbf{F}_{\mathrm{eiv}}^T =
 \begin{pmatrix}
  	        {e_{2}\,e_{3}\;  u^*} 	 	\\
@@ -1000,5 +1002,5 @@
 \begin{subequations}\label{eq:triad:allskewflux}
   \begin{flalign}\label{eq:triad:vect_skew_flux}
-    \vect{F}_\mathrm{eiv}(T) &\equiv
+    \vect{F}_{\mathrm{eiv}}(T) &\equiv
     \sum_{\substack{i_p,\,k_p}}
     \begin{pmatrix}