Index: /branches/NERC/dev_r5518_GO6_CO2_cmip/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml
===================================================================
--- /branches/NERC/dev_r5518_GO6_CO2_cmip/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 9379)
+++ /branches/NERC/dev_r5518_GO6_CO2_cmip/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 9380)
@@ -77,67 +77,67 @@
        <field id="CHN"      long_name="Chl-a concentration in non-diatom phytoplankton"   unit="mg Chl/m3" />
        <field id="CHN_E3T"  long_name="CHN * E3T"                                         unit="mg Chl/m2"  > CHN * e3t </field > 
-       <field id="CHN_INV"  field_ref="CHN_E3T"                                           unit="mg Chl/m2"   grid_ref="vert_sum" />
-       <field id="SURF_CHN" field_ref="CHN"                                               unit="mg Chl/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="CHN_INV"  field_ref="CHN_E3T"   long_name="CHN Inventory"               unit="mg Chl/m2"   grid_ref="vert_sum" />
+       <field id="SURF_CHN" field_ref="CHN"       long_name="CHN Surface concentration"   unit="mg Chl/m3"   grid_ref="grid_T_surface_extract" />
        <field id="CHD"      long_name="Chl-a concentration in     diatom phytoplankton"   unit="mg Chl/m3" />
        <field id="CHD_E3T"  long_name="CHD * E3T"                                         unit="mg Chl/m2"  > CHD * e3t </field >
-       <field id="CHD_INV"  field_ref="CHD_E3T"                                           unit="mg Chl/m2"   grid_ref="vert_sum" />
-       <field id="SURF_CHD" field_ref="CHD"                                               unit="mg Chl/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="CHD_INV"  field_ref="CHD_E3T"   long_name="CHD Inventory"               unit="mg Chl/m2"   grid_ref="vert_sum" />
+       <field id="SURF_CHD" field_ref="CHD"       long_name="CHD Surface concentration"   unit="mg Chl/m3"   grid_ref="grid_T_surface_extract" />
        <field id="PHN"      long_name="non-diatom phytoplankton"                          unit="mmol-N/m3" />
        <field id="PHN_E3T"  long_name="PHN * E3T"                                         unit="mmol-N/m2"  > PHN * e3t </field >
-       <field id="PHN_INV"  field_ref="PHN_E3T"                                           unit="mmol-N/m2"   grid_ref="vert_sum" />
-       <field id="SURF_PHN" field_ref="PHN"                                               unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="PHN_INV"  field_ref="PHN_E3T"   long_name="PHN Inventory"               unit="mmol-N/m2"   grid_ref="vert_sum" />
+       <field id="SURF_PHN" field_ref="PHN"       long_name="PHN Surface concentration"   unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
        <field id="PHD"      long_name="diatom     phytoplankton"                          unit="mmol-N/m3" />
        <field id="PHD_E3T"  long_name="PHD * E3T"                                         unit="mmol-N/m2"  > PHD * e3t </field >
-       <field id="PHD_INV"  field_ref="PHD_E3T"                                           unit="mmol-N/m2"   grid_ref="vert_sum" />
-       <field id="SURF_PHD" field_ref="PHD"                                               unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="PHD_INV"  field_ref="PHD_E3T"   long_name="PHD Inventory"               unit="mmol-N/m2"   grid_ref="vert_sum" />
+       <field id="SURF_PHD" field_ref="PHD"       long_name="PHD Surface concentration"   unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
        <field id="ZMI"      long_name="micro zooplankton"                                 unit="mmol-N/m3" />
        <field id="ZMI_E3T"  long_name="ZMI * E3T"                                         unit="mmol-N/m2"  > ZMI * e3t </field >
-       <field id="ZMI_INV"  field_ref="ZMI_E3T"                                           unit="mmol-N/m2"   grid_ref="vert_sum" />
-       <field id="SURF_ZMI" field_ref="ZMI"                                               unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="ZMI_INV"  field_ref="ZMI_E3T"   long_name="ZMI Inventory"               unit="mmol-N/m2"   grid_ref="vert_sum" />
+       <field id="SURF_ZMI" field_ref="ZMI"       long_name="ZMI Surface concentration"   unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
        <field id="ZME"      long_name="meso  zooplankton"                                 unit="mmol-N/m3" />
        <field id="ZME_E3T"  long_name="ZME * E3T"                                         unit="mmol-N/m2"  > ZME * e3t </field >
-       <field id="ZME_INV"  field_ref="ZME_E3T"                                           unit="mmol-N/m2"   grid_ref="vert_sum" />
-       <field id="SURF_ZME" field_ref="ZME"                                               unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="ZME_INV"  field_ref="ZME_E3T"   long_name="ZME Inventory"               unit="mmol-N/m2"   grid_ref="vert_sum" />
+       <field id="SURF_ZME" field_ref="ZME"       long_name="ZME Surface concentration"   unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
        <field id="DIN"      long_name="dissolved inorganic nitrogen"                      unit="mmol-N/m3" />
        <field id="DIN_E3T"  long_name="DIN * E3T"                                         unit="mmol-N/m2"  > DIN * e3t </field >
-       <field id="DIN_INV"  field_ref="DIN_E3T"                                           unit="mmol-N/m2"   grid_ref="vert_sum" />
-       <field id="SURF_DIN" field_ref="DIN"                                               unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="DIN_INV"  field_ref="DIN_E3T"   long_name="DIN Inventory"               unit="mmol-N/m2"   grid_ref="vert_sum" />
+       <field id="SURF_DIN" field_ref="DIN"       long_name="DIN Surface concentration"   unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
        <field id="SIL"      long_name="dissolved silicic acid"                            unit="mmolSi/m3" />
        <field id="SIL_E3T"  long_name="SIL * E3T"                                         unit="mmolSi/m2"  > SIL * e3t </field >
-       <field id="SIL_INV"  field_ref="SIL_E3T"                                           unit="mmolSi/m2"   grid_ref="vert_sum" />
-       <field id="SURF_SIL" field_ref="SIL"                                               unit="mmolSi/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="SIL_INV"  field_ref="SIL_E3T"   long_name="SIL Inventory"               unit="mmolSi/m2"   grid_ref="vert_sum" />
+       <field id="SURF_SIL" field_ref="SIL"       long_name="SIL Surface concentration"   unit="mmolSi/m3"   grid_ref="grid_T_surface_extract" />
        <field id="FER"      long_name="dissolved iron"                                    unit="mmolFe/m3" />
        <field id="FER_E3T"  long_name="FER * E3T"                                         unit="mmolFe/m2"  > FER * e3t </field >
-       <field id="FER_INV"  field_ref="FER_E3T"                                           unit="mmolFe/m2"   grid_ref="vert_sum" />
-       <field id="SURF_FER" field_ref="FER"                                               unit="mmolFe/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="FER_INV"  field_ref="FER_E3T"   long_name="FER Inventory"               unit="mmolFe/m2"   grid_ref="vert_sum" />
+       <field id="SURF_FER" field_ref="FER"       long_name="FER Surface concentration"   unit="mmolFe/m3"   grid_ref="grid_T_surface_extract" />
        <field id="DET"      long_name="detrital nitrogen"                                 unit="mmol-N/m3" />
        <field id="DET_E3T"  long_name="DET * E3T"                                         unit="mmol-N/m2"  > DET * e3t </field >
-       <field id="DET_INV"  field_ref="DET_E3T"                                           unit="mmol-N/m2"   grid_ref="vert_sum" />
-       <field id="SURF_DET" field_ref="DET"                                               unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="DET_INV"  field_ref="DET_E3T"   long_name="DET Inventory"               unit="mmol-N/m2"   grid_ref="vert_sum" />
+       <field id="SURF_DET" field_ref="DET"       long_name="DET Surface concentration"   unit="mmol-N/m3"   grid_ref="grid_T_surface_extract" />
        <field id="PDS"      long_name="biogenic silicon in diatom phytoplankton"          unit="mmolSi/m3" />
        <field id="PDS_E3T"  long_name="PDS * E3T"                                         unit="mmolSi/m2"  > PDS * e3t </field >
-       <field id="PDS_INV"  field_ref="PDS_E3T"                                           unit="mmolSi/m2"   grid_ref="vert_sum" />
-       <field id="SURF_PDS" field_ref="PDS"                                               unit="mmolSi/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="PDS_INV"  field_ref="PDS_E3T"   long_name="PDS Inventory"               unit="mmolSi/m2"   grid_ref="vert_sum" />
+       <field id="SURF_PDS" field_ref="PDS"       long_name="PDS Surface concentration"   unit="mmolSi/m3"   grid_ref="grid_T_surface_extract" />
        <field id="DTC"      long_name="detrital carbon"                                   unit="mmol-C/m3" />
        <field id="DTC_E3T"  long_name="DTC * E3T"                                         unit="mmol-C/m2"  > DTC * e3t </field >
-       <field id="DTC_INV"  field_ref="DTC_E3T"                                           unit="mmol-C/m2"   grid_ref="vert_sum" />
-       <field id="SURF_DTC" field_ref="DTC"                                               unit="mmol-C/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="DTC_INV"  field_ref="DTC_E3T"   long_name="DTC Inventory"               unit="mmol-C/m2"   grid_ref="vert_sum" />
+       <field id="SURF_DTC" field_ref="DTC"       long_name="DTC Surface concentration"   unit="mmol-C/m3"   grid_ref="grid_T_surface_extract" />
        <field id="DiC"      long_name="dissolved inorganic carbon"                        unit="mmol-C/m3" />
        <field id="DiC_E3T"  long_name="DiC * E3T"                                         unit="mmol-C/m2"  > DiC * e3t </field >
-       <field id="DiC_INV"  field_ref="DiC_E3T"                                           unit="mmol-C/m2"   grid_ref="vert_sum" />
-       <field id="SURF_DiC" field_ref="DiC"                                               unit="mmol-C/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="DiC_INV"  field_ref="DiC_E3T"   long_name="DiC Inventory"               unit="mmol-C/m2"   grid_ref="vert_sum" />
+       <field id="SURF_DiC" field_ref="DiC"       long_name="DiC Surface concentration"   unit="mmol-C/m3"   grid_ref="grid_T_surface_extract" />
        <field id="ALK"      long_name="alkalinity"                                        unit="meq/m3"    />
        <field id="ALK_E3T"  long_name="ALK * E3T"                                         unit="meq/m2"     > ALK * e3t </field >
-       <field id="ALK_INV"  field_ref="ALK_E3T"                                           unit="meq/m2"      grid_ref="vert_sum" />
-       <field id="SURF_ALK" field_ref="ALK"                                               unit="meq/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="ALK_INV"  field_ref="ALK_E3T"   long_name="ALK Inventory"               unit="meq/m2"      grid_ref="vert_sum" />
+       <field id="SURF_ALK" field_ref="ALK"       long_name="ALK Surface concentration"   unit="meq/m3"   grid_ref="grid_T_surface_extract" />
        <field id="OXY"      long_name="dissolved oxygen"                                  unit="mmolO2/m3" />
        <field id="OXY_E3T"  long_name="OXY * E3T"                                         unit="mmolO2/m2"  > OXY * e3t </field >
-       <field id="OXY_INV"  field_ref="OXY_E3T"                                           unit="mmolO2/m2"   grid_ref="vert_sum" />
-       <field id="SURF_OXY" field_ref="OXY"                                               unit="mmolO2/m3"   grid_ref="grid_T_surface_extract" />
+       <field id="OXY_INV"  field_ref="OXY_E3T"   long_name="OXY Inventory"               unit="mmolO2/m2"   grid_ref="vert_sum" />
+       <field id="SURF_OXY" field_ref="OXY"       long_name="OXY Surface concentration"   unit="mmolO2/m3"   grid_ref="grid_T_surface_extract" />
 
       <!-- Ideal traceurs : variables available with key_idtra -->
        <field id="IDTRA"       long_name="Ideal traceur concentration "             unit="mmol/m3"    />
        <field id="IDTRA_E3T"   long_name="IDTRA * E3T"                              unit="mmol/m2"  > IDTRA * e3t </field >
-       <field id="IDTRA_INV"   field_ref="IDTRA_E3T"                                unit="mmol/m2"   grid_ref="vert_sum" />
+       <field id="IDTRA_INV"   field_ref="IDTRA_E3T"   long_name="Age Inventory"    unit="mmol/m2"   grid_ref="vert_sum" />
 
        <!-- PISCES with Kriest parametisation : variables available with key_kriest -->
@@ -154,21 +154,21 @@
        <field id="CFC11"       long_name="CFC-11 Concentration"                     unit="umol/m3" />
        <field id="CFC11_E3T"   long_name="CFC11 * E3T"                              unit="umol/m2"  > CFC11 * e3t </field >
-       <field id="CFC11_INV"   field_ref="CFC11_E3T"                                unit="umol/m2"   grid_ref="vert_sum" />
+       <field id="CFC11_INV"   field_ref="CFC11_E3T"   long_name="Age Inventory"    unit="umol/m2"   grid_ref="vert_sum" />
        <!-- CFC12 : variables available with key_cfc -->
        <field id="CFC12"       long_name="CFC-12 Concentration"                     unit="umol/m3" />
        <field id="CFC12_E3T"   long_name="CFC12 * E3T"                              unit="umol/m2"  > CFC12 * e3t </field >
-       <field id="CFC12_INV"   field_ref="CFC12_E3T"                                unit="umol/m2"   grid_ref="vert_sum" />
+       <field id="CFC12_INV"   field_ref="CFC12_E3T"   long_name="Age Inventory"    unit="umol/m2"   grid_ref="vert_sum" />
        <!-- SF6 : variables available with key_cfc -->
        <field id="SF6"         long_name="SF6 Concentration"                        unit="umol/m3" />
        <field id="SF6_E3T"     long_name="SF6 * E3T"                                unit="umol/m2"  > SF6 * e3t </field >
-       <field id="SF6_INV"     field_ref="SF6_E3T"                                  unit="umol/m2"   grid_ref="vert_sum" />
+       <field id="SF6_INV"     field_ref="SF6_E3T"   long_name="Age Inventory"      unit="umol/m2"   grid_ref="vert_sum" />
        <!-- Bomb C14 : variables available with key_c14b -->
        <field id="C14B"        long_name="Bomb C14 Concentration"                   unit="1"         />
        <field id="C14B_E3T"    long_name="C14B * E3T"                               unit="m"  > C14B * e3t </field >
-       <field id="C14B_INV"    field_ref="C14B_E3T"                                 unit="m"   grid_ref="vert_sum" />
+       <field id="C14B_INV"    field_ref="C14B_E3T"    long_name="Age Inventory"    unit="m"   grid_ref="vert_sum" />
        <!-- AGE : variables available with key_age -->
        <field id="Age"        long_name="Sea Water Age Since Surface contact"       unit="yr"         />
        <field id="Age_E3T"    long_name="Age * E3T"                                 unit="yr * m"  > Age * e3t </field >
-       <field id="Age_INV"    field_ref="Age_E3T"                                   unit="yr * m"   grid_ref="vert_sum" />
+       <field id="Age_INV"    field_ref="Age_E3T"   long_name="Age Inventory"       unit="yr * m"   grid_ref="vert_sum" />
      </field_group>
 
@@ -1339,5 +1339,5 @@
        <field id="XAD_CFC11_INV"  field_ref="XAD_CFC11_E3T" long_name="XAD_CFC11 Inventory" unit="umol/m2/s" grid_ref="vert_sum" />
        <field id="YAD_CFC11"      long_name="CFC11 Y-Advection Trend"                       unit="umol/m3/s" />
-       <field id="YAD_CFC11_E3T"  long_name="YAD_CFC11 * E3T"                           unit="umol/m2/s" > YAD_CFC11 * e3t </field>
+       <field id="YAD_CFC11_E3T"  long_name="YAD_CFC11 * E3T"                               unit="umol/m2/s" > YAD_CFC11 * e3t </field>
        <field id="YAD_CFC11_INV"  field_ref="YAD_CFC11_E3T" long_name="YAD_CFC11 Inventory" unit="umol/m2/s" grid_ref="vert_sum" />
        <field id="ZAD_CFC11"      long_name="CFC11 Z-Advection Trend"                       unit="umol/m3/s" />
@@ -1609,5 +1609,5 @@
        <field id="TOT_IDTRA"      long_name="Ideal traceur Total Trend "                     unit="mmol/m3/s"    />
        <field id="TOT_IDTRA_E3T"  long_name="TOT_IDTRA * E3T"                                unit="mmol/m2/s" > TOT_IDTRA * e3t </field>
-       <field id="TOT_IDTRA_INV"  field_ref="TOT_IDTRA_E3T" long_name="TOT_IDTRA Inventory" unit="mmol/m2/s" grid_ref="vert_sum" />
+       <field id="TOT_IDTRA_INV"  field_ref="TOT_IDTRA_E3T" long_name="TOT_IDTRA Inventory"  unit="mmol/m2/s" grid_ref="vert_sum" />
 
        <!-- CFC11 : variables available with key_cfc -->