Index: trunk/NEMOGCM/CONFIG/ORCA2_OFF_TRC/EXP00/CFCs_CDIAC.dat
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_OFF_TRC/EXP00/CFCs_CDIAC.dat	(revision 9401)
+++ trunk/NEMOGCM/CONFIG/ORCA2_OFF_TRC/EXP00/CFCs_CDIAC.dat	(revision 9401)
@@ -0,0 +1,91 @@
+// Source   : https://www.nodc.noaa.gov/ocads/oceans/CFC_ATM_Hist2015.html  
+// Dataset  : CDIAC Atmospheric Histories (1765-2015) for CFC-11, CFC-12, SF6 (Bullister, 2017) 
+// Units    : mole_fraction_of_gas_in_air (ppt) 
+// Gas (Lifetime in yrs): CFC-11 (45) ; CFC-12 (100) ; SF6 (3200) 
+// --------------- 
+// Time    CFC11_NH   CFC11_SH   CFC12_NH   CFC12_SH     SF6_NH     SF6_SH  
+ 1931.50     0.0000     0.0000     0.0000     0.0000     0.0000     0.0000
+ 1932.50     0.0000     0.0000     0.0000     0.0000     0.0000     0.0000
+ 1933.50     0.0000     0.0000     0.0000     0.0000     0.0000     0.0000
+ 1934.50     0.0000     0.0000     0.0000     0.0000     0.0000     0.0000
+ 1935.50     0.0000     0.0000     0.0000     0.0000     0.0000     0.0000
+ 1936.50     0.0000     0.0000     0.1000     0.0000     0.0000     0.0000
+ 1937.50     0.0000     0.0000     0.1000     0.1000     0.0000     0.0000
+ 1938.50     0.0000     0.0000     0.2000     0.1000     0.0000     0.0000
+ 1939.50     0.0000     0.0000     0.3000     0.2000     0.0000     0.0000
+ 1940.50     0.0000     0.0000     0.4000     0.3000     0.0000     0.0000
+ 1941.50     0.0000     0.0000     0.5000     0.4000     0.0000     0.0000
+ 1942.50     0.0000     0.0000     0.7000     0.5000     0.0000     0.0000
+ 1943.50     0.0000     0.0000     0.9000     0.7000     0.0000     0.0000
+ 1944.50     0.0000     0.0000     1.2000     0.9000     0.0000     0.0000
+ 1945.50     0.1000     0.0000     1.7000     1.2000     0.0000     0.0000
+ 1946.50     0.1000     0.1000     2.3000     1.7000     0.0000     0.0000
+ 1947.50     0.1000     0.1000     3.4000     2.4000     0.0000     0.0000
+ 1948.50     0.2000     0.1000     4.8000     3.4000     0.0000     0.0000
+ 1949.50     0.4000     0.2000     6.1000     4.7000     0.0000     0.0000
+ 1950.50     0.7000     0.4000     7.6000     6.0000     0.0000     0.0000
+ 1951.50     1.0100     0.7000     9.2000     7.4000     0.0000     0.0000
+ 1952.50     1.5100     1.0100    11.0000     9.0000     0.0000     0.0000
+ 1953.50     2.2100     1.5100    12.8000    10.7000     0.0400     0.0400
+ 1954.50     3.0200     2.2100    15.0000    12.6000     0.0400     0.0400
+ 1955.50     4.1200     3.0200    17.4000    14.7000     0.0400     0.0400
+ 1956.50     5.3300     4.0200    20.2000    17.1000     0.0400     0.0400
+ 1957.50     6.8300     5.2300    23.4000    19.9000     0.0500     0.0400
+ 1958.50     8.1400     6.5300    26.8000    23.0000     0.0500     0.0400
+ 1959.50     9.4500     7.8400    30.5000    26.3000     0.0500     0.0500
+ 1960.50    11.0600     9.1500    35.0000    30.1000     0.0500     0.0500
+ 1961.50    13.2700    10.8500    40.0000    34.4000     0.0600     0.0600
+ 1962.50    16.1800    13.0700    45.8000    39.4000     0.0700     0.0600
+ 1963.50    19.6000    15.7800    52.5000    45.1000     0.0800     0.0700
+ 1964.50    23.7200    19.2000    60.4000    51.8000     0.0900     0.0800
+ 1965.50    28.4400    23.1200    69.3000    59.5000     0.1100     0.1000
+ 1966.50    33.6700    27.6400    79.2000    68.2000     0.1300     0.1200
+ 1967.50    39.4000    32.6600    90.3000    77.9000     0.1500     0.1400
+ 1968.50    46.0300    38.2900   102.8000    88.8000     0.1800     0.1700
+ 1969.50    53.7700    44.8200   116.8000   101.1000     0.2100     0.1900
+ 1970.50    62.4100    52.2600   132.0000   114.7000     0.2300     0.2200
+ 1971.50    72.0600    60.7000   148.4000   129.6000     0.2600     0.2400
+ 1972.50    82.7100    69.9500   166.1000   145.7000     0.3000     0.2800
+ 1973.50    94.8700    80.4000   185.8000   163.3000     0.3400     0.3100
+ 1974.50   108.3400    92.1600   207.1000   182.5000     0.3800     0.3500
+ 1975.50   121.4100   104.7200   228.2000   202.9000     0.4400     0.4000
+ 1976.50   133.9700   117.0900   248.1000   223.2000     0.5000     0.4600
+ 1977.50   145.9300   129.3500   266.9000   242.7000     0.5800     0.5300
+ 1978.50   156.5800   140.8000   284.3000   261.2000     0.6600     0.6100
+ 1979.50   168.3400   148.7400   306.1000   273.5000     0.7600     0.7000
+ 1980.50   176.6800   159.3000   323.2000   292.3000     0.8800     0.8100
+ 1981.50   184.3200   167.8400   339.6000   308.8000     1.0000     0.9300
+ 1982.50   191.4600   176.0800   353.4000   325.5000     1.1300     1.0400
+ 1983.50   199.3000   184.5200   369.0000   342.6000     1.2700     1.1700
+ 1984.50   208.0400   192.4600   385.7000   359.4000     1.4000     1.2900
+ 1985.50   217.9900   202.0100   403.4000   378.2000     1.5500     1.4300
+ 1986.50   229.3500   211.3600   424.3000   396.5000     1.7100     1.5800
+ 1987.50   241.6100   222.2100   444.0000   416.3000     1.8800     1.7300
+ 1988.50   252.8600   233.2700   465.4000   435.8000     2.0500     1.8900
+ 1989.50   259.3000   242.1100   483.6000   454.4000     2.2200     2.0500
+ 1990.50   265.8300   251.0600   497.7000   472.7000     2.4100     2.2200
+ 1991.50   268.2400   256.6800   506.0000   487.3000     2.6200     2.4200
+ 1992.50   268.1400   260.8000   516.3000   498.3000     2.8500     2.6300
+ 1993.50   269.5500   262.5100   523.2000   507.0000     3.0900     2.8400
+ 1994.50   269.6500   263.7200   528.5000   514.8000     3.3300     3.0700
+ 1995.50   268.3400   263.2200   533.4000   521.0000     3.5800     3.3000
+ 1996.50   266.9300   262.9100   537.3000   526.5000     3.8600     3.5500
+ 1997.50   265.7300   262.0100   540.1000   530.8000     4.0700     3.8100
+ 1998.50   264.5200   261.0100   542.9000   534.3000     4.2500     4.0100
+ 1999.50   263.1200   259.9000   544.4000   537.2000     4.4800     4.2500
+ 2000.50   261.7100   258.2900   545.9000   539.0000     4.6800     4.4600
+ 2001.50   260.0000   256.9800   546.5000   540.6000     4.9000     4.6500
+ 2002.50   258.1900   255.0800   546.7000   541.3000     5.1400     4.8800
+ 2003.50   256.1800   253.2700   546.7000   541.6000     5.3700     5.0700
+ 2004.50   253.9700   251.3600   545.7000   541.5000     5.5800     5.3000
+ 2005.50   251.9600   249.1500   544.9000   540.7000     5.8000     5.5100
+ 2006.50   249.5500   247.3400   543.1000   539.8000     6.0400     5.7500
+ 2007.50   247.5400   245.0300   541.1000   538.1000     6.3300     6.0300
+ 2008.50   245.6300   243.1200   538.6000   536.2000     6.6200     6.2900
+ 2009.50   243.6100   241.0500   536.1200   533.4700     6.8900     6.5800
+ 2010.50   241.3100   239.1500   533.2600   531.0300     7.2100     6.8700
+ 2011.50   239.4000   236.8400   530.6000   528.5300     7.4600     7.1700
+ 2012.50   236.8900   234.7700   527.2000   526.0000     7.7300     7.4300
+ 2013.50   235.5700   232.8800   525.2200   523.2500     8.0900     7.7300
+ 2014.50   234.9700   231.4900   522.9700   521.0000     8.4000     8.1100
+ 2015.50   234.3600   230.0900   520.7100   518.7400     8.7200     8.5000
Index: trunk/NEMOGCM/CONFIG/SHARED/namelist_trc_ref
===================================================================
--- trunk/NEMOGCM/CONFIG/SHARED/namelist_trc_ref	(revision 8698)
+++ trunk/NEMOGCM/CONFIG/SHARED/namelist_trc_ref	(revision 9401)
@@ -11,5 +11,5 @@
    !
    ! Formatted file of annual hemisperic CFCs concentration in the atmosphere (ppt)
-   clname     = 'CFCs_in_air_CMIP6.dat'
+   clname     = 'CFCs_CDIAC.dat'
 /
 !